"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchRuleSetFromSeeds = exports.fetchRuleSetFromSeeds = exports.findRuleSetPda = exports.getRuleSetGpaBuilder = exports.safeFetchAllRuleSet = exports.fetchAllRuleSet = exports.safeFetchRuleSet = exports.fetchRuleSet = exports.deserializeRuleSet = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const hooked_1 = require("../../hooked");
const types_1 = require("../types");
function deserializeRuleSet(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, (0, hooked_1.getRuleSetAccountDataSerializer)());
}
exports.deserializeRuleSet = deserializeRuleSet;
async function fetchRuleSet(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'RuleSet');
    return deserializeRuleSet(maybeAccount);
}
exports.fetchRuleSet = fetchRuleSet;
async function safeFetchRuleSet(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeRuleSet(maybeAccount) : null;
}
exports.safeFetchRuleSet = safeFetchRuleSet;
async function fetchAllRuleSet(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'RuleSet');
        return deserializeRuleSet(maybeAccount);
    });
}
exports.fetchAllRuleSet = fetchAllRuleSet;
async function safeFetchAllRuleSet(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeRuleSet(maybeAccount));
}
exports.safeFetchAllRuleSet = safeFetchAllRuleSet;
function getRuleSetGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplTokenAuthRules', 'auth9SigNpDKz4sJJ1DfCTuZrZNSAgh9sFD3rboVmgg');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        revisionMapLocation: [1, (0, serializers_1.u64)()],
        revisions: [9, (0, serializers_1.bytes)()],
    })
        .deserializeUsing((account) => deserializeRuleSet(account));
}
exports.getRuleSetGpaBuilder = getRuleSetGpaBuilder;
function findRuleSetPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplTokenAuthRules', 'auth9SigNpDKz4sJJ1DfCTuZrZNSAgh9sFD3rboVmgg');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('rule_set'),
        (0, serializers_1.publicKey)().serialize(seeds.owner),
        (0, serializers_1.string)({ size: 'variable' }).serialize(seeds.name),
    ]);
}
exports.findRuleSetPda = findRuleSetPda;
async function fetchRuleSetFromSeeds(context, seeds, options) {
    return fetchRuleSet(context, findRuleSetPda(context, seeds), options);
}
exports.fetchRuleSetFromSeeds = fetchRuleSetFromSeeds;
async function safeFetchRuleSetFromSeeds(context, seeds, options) {
    return safeFetchRuleSet(context, findRuleSetPda(context, seeds), options);
}
exports.safeFetchRuleSetFromSeeds = safeFetchRuleSetFromSeeds;
//# sourceMappingURL=ruleSet.js.map