import { Serializer } from '@metaplex-foundation/umi/serializers';
import { RuleSetRevisionV1 } from './v1';
import { RuleSetRevisionV2 } from './v2';
export declare type RuleSetRevision = RuleSetRevisionV1 | RuleSetRevisionV2;
export declare const getRuleSetRevisionSerializer: () => Serializer<RuleSetRevision>;
export declare const getRuleSetRevisionSerializerFromVersion: <T extends RuleSetRevision>(version: T["libVersion"]) => Serializer<T, T>;
export declare const isRuleSetV1: (ruleSet: RuleSetRevision) => ruleSet is RuleSetRevisionV1;
export declare const isRuleSetV2: (ruleSet: RuleSetRevision) => ruleSet is RuleSetRevisionV2;
export declare const getRuleSetRevisionFromJson: (json: string) => RuleSetRevision;
export declare const getLatestRuleSetRevision: (buffer: Uint8Array) => RuleSetRevision;
