"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isProgramOwnedListRuleV2 = exports.getProgramOwnedListRuleV2Serializer = exports.programOwnedListV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const programOwnedListV2 = (field, programs) => ({
    type: 'ProgramOwnedList',
    field,
    programs: programs.map((program) => (0, umi_1.publicKey)(program)),
});
exports.programOwnedListV2 = programOwnedListV2;
const getProgramOwnedListRuleV2Serializer = () => (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(ruleType_1.RuleTypeV2.ProgramOwnedList, (0, serializers_1.struct)([
    ['field', (0, serializers_1.string)({ size: 32 })],
    ['programs', (0, serializers_1.array)((0, serializers_1.publicKey)(), { size: 'remainder' })],
]));
exports.getProgramOwnedListRuleV2Serializer = getProgramOwnedListRuleV2Serializer;
const isProgramOwnedListRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'ProgramOwnedList';
exports.isProgramOwnedListRuleV2 = isProgramOwnedListRuleV2;
//# sourceMappingURL=programOwnedList.js.map