"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPubkeyMatchRuleV2 = exports.getPubkeyMatchRuleV2Serializer = exports.pubkeyMatchV2 = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const pubkeyMatchV2 = (field, publicKey) => ({
    type: 'PubkeyMatch',
    publicKey: (0, umi_1.publicKey)(publicKey),
    field,
});
exports.pubkeyMatchV2 = pubkeyMatchV2;
const getPubkeyMatchRuleV2Serializer = () => (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(ruleType_1.RuleTypeV2.PubkeyMatch, (0, serializers_1.struct)([
    ['publicKey', (0, serializers_1.publicKey)()],
    ['field', (0, serializers_1.string)({ size: 32 })],
]));
exports.getPubkeyMatchRuleV2Serializer = getPubkeyMatchRuleV2Serializer;
const isPubkeyMatchRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'PubkeyMatch';
exports.isPubkeyMatchRuleV2 = isPubkeyMatchRuleV2;
//# sourceMappingURL=pubkeyMatch.js.map