"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPubkeyTreeMatchRuleV2 = exports.getPubkeyTreeMatchRuleV2Serializer = exports.pubkeyTreeMatchV2 = void 0;
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const rule_1 = require("./rule");
const ruleHeader_1 = require("./ruleHeader");
const ruleType_1 = require("./ruleType");
const pubkeyTreeMatchV2 = (pubkeyField, proofField, root) => ({
    type: 'PubkeyTreeMatch',
    pubkeyField,
    proofField,
    root: [...root],
});
exports.pubkeyTreeMatchV2 = pubkeyTreeMatchV2;
const getPubkeyTreeMatchRuleV2Serializer = () => (0, ruleHeader_1.wrapSerializerInRuleHeaderV2)(ruleType_1.RuleTypeV2.PubkeyTreeMatch, (0, serializers_1.struct)([
    ['pubkeyField', (0, serializers_1.string)({ size: 32 })],
    ['proofField', (0, serializers_1.string)({ size: 32 })],
    [
        'root',
        (0, serializers_1.mapSerializer)((0, serializers_1.bytes)({ size: 32 }), (v) => new Uint8Array(v), (v) => [...v]),
    ],
]));
exports.getPubkeyTreeMatchRuleV2Serializer = getPubkeyTreeMatchRuleV2Serializer;
const isPubkeyTreeMatchRuleV2 = (rule) => (0, rule_1.isRuleV2)(rule) && rule.type === 'PubkeyTreeMatch';
exports.isPubkeyTreeMatchRuleV2 = isPubkeyTreeMatchRuleV2;
//# sourceMappingURL=pubkeyTreeMatch.js.map