import { Context, Signer, TransactionBuilderGroup } from '@metaplex-foundation/umi';
import { RuleSetRevision } from './revisions';
export declare type WriteRuleSetToBufferV1 = {
    /** Payer and creator of the RuleSet buffer. */
    payer?: Signer;
    /** The new revision to write to the buffer. */
    ruleSetRevision: RuleSetRevision;
    /**
     * The size of each chunk to write to the buffer.
     * @default `900`
     */
    chunkSize?: number;
};
export declare const writeRuleSetToBufferV1: (context: Pick<Context, 'eddsa' | 'programs' | 'payer' | 'transactions'>, input: WriteRuleSetToBufferV1) => TransactionBuilderGroup;
